/*
www.sourceforge.net/projects/tinyxml
Original code (2.0 and earlier )copyright (c) 2000-2002 Lee Thomason (www.grinninglizard.com)

This software is provided 'as-is', without any express or implied
warranty. In no event will the authors be held liable for any
damages arising from the use of this software.

Permission is granted to anyone to use this software for any
purpose, including commercial applications, and to alter it and
redistribute it freely, subject to the following restrictions:

1. The origin of this software must not be misrepresented; you must
not claim that you wrote the original software. If you use this
software in a product, an acknowledgment in the product documentation
would be appreciated but is not required.

2. Altered source versions must be plainly marked as such, and
must not be misrepresented as being the original software.

3. This notice may not be removed or altered from any source
distribution.
*/

/*
In accordance with item 2 of the above license,
this file has been modified from the original version,
to provide a minimal pull-parse back-end that cuts
down on the memory footprint when doing read-only operations.
*/

#include <ctype.h>
#include "tinyxml.h"

#ifdef TIXML_USE_STL
#include <sstream>
#endif

bool TiPullXmlBase::condenseWhiteSpace = true;

void TiPullXmlBase::PutString( const TIXML_STRING& str, TIXML_OSTREAM* stream )
{
	TIXML_STRING buffer;
	PutString( str, &buffer );
	(*stream) << buffer;
}

void TiPullXmlBase::PutString( const TIXML_STRING& str, TIXML_STRING* outString )
{
	int i=0;

	while( i<(int)str.length() )
	{
		int c = str[i];

		if (    c == '&' 
		     && i < ( (int)str.length() - 2 )
			 && str[i+1] == '#'
			 && str[i+2] == 'x' )
		{
			// Hexadecimal character reference.
			// Pass through unchanged.
			// &#xA9;	-- copyright symbol, for example.
			while ( i<(int)str.length() )
			{
				outString->append( str.c_str() + i, 1 );
				++i;
				if ( str[i] == ';' )
					break;
			}
		}
		else if ( c == '&' )
		{
			outString->append( entity[0].str, entity[0].strLength );
			++i;
		}
		else if ( c == '<' )
		{
			outString->append( entity[1].str, entity[1].strLength );
			++i;
		}
		else if ( c == '>' )
		{
			outString->append( entity[2].str, entity[2].strLength );
			++i;
		}
		else if ( c == '\"' )
		{
			outString->append( entity[3].str, entity[3].strLength );
			++i;
		}
		else if ( c == '\'' )
		{
			outString->append( entity[4].str, entity[4].strLength );
			++i;
		}
		else if ( c < 32 || c > 126 )
		{
			// Easy pass at non-alpha/numeric/symbol
			// 127 is the delete key. Below 32 is symbolic.
			char buf[ 32 ];
			sprintf( buf, "&#x%02X;", (unsigned) ( c & 0xff ) );
			outString->append( buf, strlen( buf ) );
			++i;
		}
		else
		{
			char realc = (char) c;
			outString->append( &realc, 1 );
			++i;
		}
	}
}


// <-- Strange class for a bug fix. Search for STL_STRING_BUG
TiPullXmlBase::StringToBuffer::StringToBuffer( const TIXML_STRING& str )
{
	buffer = new char[ str.length()+1 ];
	if ( buffer )
	{
		strcpy( buffer, str.c_str() );
	}
}


TiPullXmlBase::StringToBuffer::~StringToBuffer()
{
	delete [] buffer;
}
// End strange bug fix. -->


TiPullXmlNode::TiPullXmlNode( NodeType _type )
:	type(_type)
{
	parent = 0;
	activeChild = 0;
}


TiPullXmlNode::~TiPullXmlNode()
{
	delete activeChild;
}


TiPullXmlNode* TiPullXmlNode::LinkActiveChild( TiPullXmlNode* node )
{
	node->parent = this;
	delete activeChild;
	activeChild = node;

	return node;
}

TiPullXmlNode* TiPullXmlNode::FirstChild( ) 
{
	if (endPosOpen.filepos < 0)
		return 0;
	TiPullXmlDocument* doc = GetDocument();
	if (!doc)
		return 0;
	const char* fileBuffer = doc->getFileBuffer();
	TiPullXmlNode* node = Identify(fileBuffer + endPosOpen.filepos);
	ParsePosition parseStart(fileBuffer + endPosOpen.filepos, endPosOpen.filepos);
	node->Parse(parseStart, fileBuffer, false);
	LinkActiveChild(node);
	return node;
}

TiPullXmlNode* TiPullXmlNode::FirstChild( const char * _value, NodeType _type ) 
{
	TiPullXmlNode* node;
	
	for (	node = FirstChild();
			node;
			node = node->NextSibling() )
	{
		if ( node->type == _type && node->value == _value )
			return node;
	}
	return 0;
}

TiPullXmlNode* TiPullXmlNode::NextSibling( ) 
{
	TiPullXmlDocument* doc = GetDocument();
	if (!doc)
		return 0;
	const char* fileBuffer = doc->getFileBuffer();
	if (endPosClose.filepos < 0)
	{
		// churn through the child nodes
		const char* p;
		ParsePosition parseStart(fileBuffer + endPosOpen.filepos, endPosOpen.filepos);
		if (!FindElementClose(parseStart, p))
			return 0;
		endPosClose.filepos = p - fileBuffer;
	}
	fileBuffer += endPosClose.filepos;
	TiPullXmlNode* node = Identify(fileBuffer);
	if (!node)
		return 0;
	ParsePosition parseStart(fileBuffer, endPosClose.filepos);
	node->Parse(parseStart, fileBuffer, false);
	if (node->Type() == UNKNOWN)
	{
		TIXML_STRING str = node->SValue();
		if (str.size() > 1 && str[0] == '/')
		{
			if (parent && parent->endPosClose.filepos < 0)
				parent->endPosClose.filepos = node->endPosClose.filepos;
			delete node;
			return 0;
		}
	}
	if (parent)
		parent->LinkActiveChild(node); // will cause "delete this" to occur
	return node;
}

TiPullXmlNode* TiPullXmlNode::NextSibling( const char * _value, NodeType _type ) 
{
	TiPullXmlNode* node;
	
	for (	node = NextSibling();
			node;
			node = node->NextSibling() )
	{
		if ( node->type == _type && node->value == _value )
			return node;
	}
	return 0;
}


TiPullXmlElement* TiPullXmlNode::FirstChildElement() 
{
	TiPullXmlNode* node;

	for (	node = FirstChild();
			node;
			node = node->NextSibling() )
	{
		if ( node->ToElement() )
			return node->ToElement();
	}
	return 0;
}


TiPullXmlElement* TiPullXmlNode::NextSiblingElement() 
{
	TiPullXmlNode* node;

	for (	node = NextSibling();
			node;
			node = node->NextSibling() )
	{
		if ( node->ToElement() )
			return node->ToElement();
	}
	return 0;
}



TiPullXmlDocument* TiPullXmlNode::GetDocument() const
{
	const TiPullXmlNode* node;

	for( node = this; node; node = node->parent )
	{
		if ( node->ToDocument() )
			return node->ToDocument();
	}
	return 0;
}


TiPullXmlElement::TiPullXmlElement (const char * _value)
: TiPullXmlNode( TiPullXmlNode::ELEMENT )
{
	value = _value;
}

TiPullXmlElement::~TiPullXmlElement()
{
	while( attributeSet.First() )
	{
		TiPullXmlAttribute* node = attributeSet.First();
		attributeSet.Remove( node );
		delete node;
	}
}

const char * TiPullXmlElement::Attribute( const char * name ) const
{
	TiPullXmlAttribute* node = attributeSet.Find( name );

	if ( node )
		return node->Value();

	return 0;
}


const char * TiPullXmlElement::Attribute( const char * name, int* i ) const
{
	const char * s = Attribute( name );
	if ( i )
	{
		if ( s )
			*i = atoi( s );
		else
			*i = 0;
	}
	return s;
}


const char * TiPullXmlElement::Attribute( const char * name, double* d ) const
{
	const char * s = Attribute( name );
	if ( d )
	{
		if ( s )
			*d = atof( s );
		else
			*d = 0;
	}
	return s;
}


int TiPullXmlElement::QueryIntAttribute( const char* name, int* ival ) const
{
	TiPullXmlAttribute* node = attributeSet.Find( name );
	if ( !node )
		return TIXML_NO_ATTRIBUTE;

	return node->QueryIntValue( ival );
}


int TiPullXmlElement::QueryDoubleAttribute( const char* name, double* dval ) const
{
	TiPullXmlAttribute* node = attributeSet.Find( name );
	if ( !node )
		return TIXML_NO_ATTRIBUTE;

	return node->QueryDoubleValue( dval );
}

void TiPullXmlElement::Print( FILE* cfile, int depth ) const
{
	assert(0);
#if 0
	int i;
	for ( i=0; i<depth; i++ )
	{
		fprintf( cfile, "    " );
	}

	fprintf( cfile, "<%s", value.c_str() );

	TiPullXmlAttribute* attrib;
	for ( attrib = attributeSet.First(); attrib; attrib = attrib->Next() )
	{
		fprintf( cfile, " " );
		attrib->Print( cfile, depth );
	}

	// There are 3 different formatting approaches:
	// 1) An element without children is printed as a <foo /> node
	// 2) An element with only a text child is printed as <foo> text </foo>
	// 3) An element with children is printed on multiple lines.
	TiPullXmlNode* node;
	if ( !firstChild )
	{
		fprintf( cfile, " />" );
	}
	else if ( firstChild == lastChild && firstChild->ToText() )
	{
		fprintf( cfile, ">" );
		firstChild->Print( cfile, depth + 1 );
		fprintf( cfile, "</%s>", value.c_str() );
	}
	else
	{
		fprintf( cfile, ">" );

		for ( node = firstChild; node; node=node->NextSibling() )
		{
			if ( !node->ToText() )
			{
				fprintf( cfile, "\n" );
			}
			node->Print( cfile, depth+1 );
		}
		fprintf( cfile, "\n" );
		for( i=0; i<depth; ++i )
		fprintf( cfile, "    " );
		fprintf( cfile, "</%s>", value.c_str() );
	}
#endif
}

void TiPullXmlElement::StreamOut( TIXML_OSTREAM * stream ) const
{
	assert(0);
#if 0
	(*stream) << "<" << value;

	TiPullXmlAttribute* attrib;
	for ( attrib = attributeSet.First(); attrib; attrib = attrib->Next() )
	{	
		(*stream) << " ";
		attrib->StreamOut( stream );
	}

	// If this node has children, give it a closing tag. Else
	// make it an empty tag.
	TiPullXmlNode* node;
	if ( firstChild )
	{ 		
		(*stream) << ">";

		for ( node = firstChild; node; node=node->NextSibling() )
		{
			node->StreamOut( stream );
		}
		(*stream) << "</" << value << ">";
	}
	else
	{
		(*stream) << " />";
	}
#endif
}

TiPullXmlDocument::TiPullXmlDocument() : TiPullXmlNode( TiPullXmlNode::DOCUMENT )
{
	tabsize = 4;
	ClearError();
}

TiPullXmlDocument::TiPullXmlDocument( const char * documentName ) : TiPullXmlNode( TiPullXmlNode::DOCUMENT )
{
	tabsize = 4;
	value = documentName;
	ClearError();
}

bool TiPullXmlDocument::LoadFile()
{
	// See STL_STRING_BUG below.
	StringToBuffer buf( value );

	if ( buf.buffer && LoadFile( buf.buffer ) )
		return true;

	return false;
}


bool TiPullXmlDocument::SaveFile() const
{
	// See STL_STRING_BUG below.
	StringToBuffer buf( value );

	if ( buf.buffer && SaveFile( buf.buffer ) )
		return true;

	return false;
}

bool TiPullXmlDocument::LoadFile( const char* filename )
{
	// Delete the existing data:
	startPos.Clear();

	// There was a really terrifying little bug here. The code:
	//		value = filename
	// in the STL case, cause the assignment method of the std::string to
	// be called. What is strange, is that the std::string had the same
	// address as it's c_str() method, and so bad things happen. Looks
	// like a bug in the Microsoft STL implementation.
	// See STL_STRING_BUG above.
	// Fixed with the StringToBuffer class.
	value = filename;

	FILE* file = fopen( value.c_str (), "r" );

	if ( file )
	{
		// Get the file size, so we can pre-allocate the string. HUGE speed impact.
		long length = 0;
		fseek( file, 0, SEEK_END );
		length = ftell( file );
		fseek( file, 0, SEEK_SET );

		// Strange case, but good to handle up front.
		if ( length == 0 )
		{
			fclose( file );
			return false;
		}

		// If we have a file, assume it is all one big XML file, and read it in.
		// The document parser may decide the document ends sooner than the entire file, however.
		TIXML_STRING data;
		data.reserve( length );

		char* tempBuffer = new char[length+1];

		long readlen = fread( tempBuffer, 1, length, file );
		tempBuffer[readlen] = '\0';

		fclose( file );

		assert(readlen <= length);
		fileBuffer = tempBuffer;

		ParsePosition parseStart(fileBuffer, 0);
		const char* p;
		Parse( parseStart, p, false );

		if (  Error() )
            return false;
        else
			return true;
	}
	SetError( TIXML_ERROR_OPENING_FILE, 0, 0 );
	return false;
}

bool TiPullXmlDocument::SaveFile( const char * filename ) const
{
	// The old c stuff lives on...
	FILE* fp = fopen( filename, "w" );
	if ( fp )
	{
		Print( fp, 0 );
		fclose( fp );
		return true;
	}
	return false;
}


void TiPullXmlDocument::Print( FILE* cfile, int depth ) const
{
	assert(0);
#if 0
	TiPullXmlNode* node;
	for ( node=FirstChild(); node; node=node->NextSibling() )
	{
		node->Print( cfile, depth );
		fprintf( cfile, "\n" );
	}
#endif
}

void TiPullXmlDocument::StreamOut( TIXML_OSTREAM * out ) const
{
	assert(0);
#if 0
	TiPullXmlNode* node;
	for ( node=FirstChild(); node; node=node->NextSibling() )
	{
		node->StreamOut( out );

		// Special rule for streams: stop after the root element.
		// The stream in code will only read one element, so don't
		// write more than one.
		if ( node->ToElement() )
			break;
	}
#endif
}


TiPullXmlAttribute* TiPullXmlAttribute::Next() const
{
	// We are using knowledge of the sentinel. The sentinel
	// have a value or name.
	if ( next->value.empty() && next->name.empty() )
		return 0;
	return next;
}


TiPullXmlAttribute* TiPullXmlAttribute::Previous() const
{
	// We are using knowledge of the sentinel. The sentinel
	// have a value or name.
	if ( prev->value.empty() && prev->name.empty() )
		return 0;
	return prev;
}


void TiPullXmlAttribute::Print( FILE* cfile, int /*depth*/ ) const
{
	TIXML_STRING n, v;

	PutString( Name(), &n );
	PutString( Value(), &v );

	if (value.find ('\"') == TIXML_STRING::npos)
		fprintf (cfile, "%s=\"%s\"", n.c_str(), v.c_str() );
	else
		fprintf (cfile, "%s='%s'", n.c_str(), v.c_str() );
}


void TiPullXmlAttribute::StreamOut( TIXML_OSTREAM * stream ) const
{
	if (value.find( '\"' ) != TIXML_STRING::npos)
	{
		PutString( name, stream );
		(*stream) << "=" << "'";
		PutString( value, stream );
		(*stream) << "'";
	}
	else
	{
		PutString( name, stream );
		(*stream) << "=" << "\"";
		PutString( value, stream );
		(*stream) << "\"";
	}
}

int TiPullXmlAttribute::QueryIntValue( int* ival ) const
{
	if ( sscanf( value.c_str(), "%d", ival ) == 1 )
		return TIXML_SUCCESS;
	return TIXML_WRONG_TYPE;
}

int TiPullXmlAttribute::QueryDoubleValue( double* dval ) const
{
	if ( sscanf( value.c_str(), "%lf", dval ) == 1 )
		return TIXML_SUCCESS;
	return TIXML_WRONG_TYPE;
}

void TiPullXmlAttribute::SetIntValue( int _value )
{
	char buf [64];
	sprintf (buf, "%d", _value);
	SetValue (buf);
}

void TiPullXmlAttribute::SetDoubleValue( double _value )
{
	char buf [64];
	sprintf (buf, "%lf", _value);
	SetValue (buf);
}

const int TiPullXmlAttribute::IntValue() const
{
	return atoi (value.c_str ());
}

const double  TiPullXmlAttribute::DoubleValue() const
{
	return atof (value.c_str ());
}

void TiPullXmlComment::Print( FILE* cfile, int depth ) const
{
	for ( int i=0; i<depth; i++ )
	{
		fputs( "    ", cfile );
	}
	fprintf( cfile, "<!--%s-->", value.c_str() );
}

void TiPullXmlComment::StreamOut( TIXML_OSTREAM * stream ) const
{
	(*stream) << "<!--";
	PutString( value, stream );
	(*stream) << "-->";
}

void TiPullXmlText::Print( FILE* cfile, int /*depth*/ ) const
{
	TIXML_STRING buffer;
	PutString( value, &buffer );
	fprintf( cfile, "%s", buffer.c_str() );
}


void TiPullXmlText::StreamOut( TIXML_OSTREAM * stream ) const
{
	PutString( value, stream );
}


TiPullXmlDeclaration::TiPullXmlDeclaration( const char * _version,
	const char * _encoding,
	const char * _standalone )
: TiPullXmlNode( TiPullXmlNode::DECLARATION )
{
	version = _version;
	encoding = _encoding;
	standalone = _standalone;
}


void TiPullXmlDeclaration::Print( FILE* cfile, int /*depth*/ ) const
{
	fprintf (cfile, "<?xml ");

	if ( !version.empty() )
		fprintf (cfile, "version=\"%s\" ", version.c_str ());
	if ( !encoding.empty() )
		fprintf (cfile, "encoding=\"%s\" ", encoding.c_str ());
	if ( !standalone.empty() )
		fprintf (cfile, "standalone=\"%s\" ", standalone.c_str ());
	fprintf (cfile, "?>");
}

void TiPullXmlDeclaration::StreamOut( TIXML_OSTREAM * stream ) const
{
	(*stream) << "<?xml ";

	if ( !version.empty() )
	{
		(*stream) << "version=\"";
		PutString( version, stream );
		(*stream) << "\" ";
	}
	if ( !encoding.empty() )
	{
		(*stream) << "encoding=\"";
		PutString( encoding, stream );
		(*stream ) << "\" ";
	}
	if ( !standalone.empty() )
	{
		(*stream) << "standalone=\"";
		PutString( standalone, stream );
		(*stream) << "\" ";
	}
	(*stream) << "?>";
}

void TiPullXmlUnknown::Print( FILE* cfile, int depth ) const
{
	for ( int i=0; i<depth; i++ )
		fprintf( cfile, "    " );
	fprintf( cfile, "%s", value.c_str() );
}

void TiPullXmlUnknown::StreamOut( TIXML_OSTREAM * stream ) const
{
	(*stream) << "<" << value << ">";		// Don't use entities hear! It is unknown.
}

TiPullXmlAttributeSet::TiPullXmlAttributeSet()
{
	sentinel.next = &sentinel;
	sentinel.prev = &sentinel;
}


TiPullXmlAttributeSet::~TiPullXmlAttributeSet()
{
	assert( sentinel.next == &sentinel );
	assert( sentinel.prev == &sentinel );
}


void TiPullXmlAttributeSet::Add( TiPullXmlAttribute* addMe )
{
	assert( !Find( addMe->Name() ) );	// Shouldn't be multiply adding to the set.

	addMe->next = &sentinel;
	addMe->prev = sentinel.prev;

	sentinel.prev->next = addMe;
	sentinel.prev      = addMe;
}

void TiPullXmlAttributeSet::Remove( TiPullXmlAttribute* removeMe )
{
	TiPullXmlAttribute* node;

	for( node = sentinel.next; node != &sentinel; node = node->next )
	{
		if ( node == removeMe )
		{
			node->prev->next = node->next;
			node->next->prev = node->prev;
			node->next = 0;
			node->prev = 0;
			return;
		}
	}
	assert( 0 );		// we tried to remove a non-linked attribute.
}

TiPullXmlAttribute*	TiPullXmlAttributeSet::Find( const char * name ) const
{
	TiPullXmlAttribute* node;

	for( node = sentinel.next; node != &sentinel; node = node->next )
	{
		if ( node->name == name )
			return node;
	}
	return 0;
}


#ifdef TIXML_USE_STL	
TIXML_ISTREAM & operator >> (TIXML_ISTREAM & in, TiPullXmlNode & base)
{
	TIXML_STRING tag;
	tag.reserve( 8 * 1000 );
	base.StreamIn( &in, &tag );

	base.Parse( tag.c_str(), 0 );
	return in;
}
#endif


TIXML_OSTREAM & operator<< (TIXML_OSTREAM & out, const TiPullXmlNode & base)
{
	base.StreamOut (& out);
	return out;
}


#ifdef TIXML_USE_STL	
std::string & operator<< (std::string& out, const TiPullXmlNode& base )
{
   std::ostringstream os_stream( std::ostringstream::out );
   base.StreamOut( &os_stream );
   
   out.append( os_stream.str() );
   return out;
}
#endif


TiPullXmlHandle TiPullXmlHandle::FirstChild() const
{
	if ( node )
	{
		TiPullXmlNode* child = node->FirstChild();
		if ( child )
			return TiPullXmlHandle( child );
	}
	return TiPullXmlHandle( 0 );
}


TiPullXmlHandle TiPullXmlHandle::FirstChild( const char * value, TiPullXmlNode::NodeType nType ) const
{
	if ( node )
	{
		TiPullXmlNode* child = node->FirstChild( value, nType );
		if ( child )
			return TiPullXmlHandle( child );
	}
	return TiPullXmlHandle( 0 );
}


TiPullXmlHandle TiPullXmlHandle::FirstChildElement() const
{
	if ( node )
	{
		TiPullXmlElement* child = node->FirstChildElement();
		if ( child )
			return TiPullXmlHandle( child );
	}
	return TiPullXmlHandle( 0 );
}


TiPullXmlHandle TiPullXmlHandle::FirstChildElement( const char * value ) const
{
	if ( node )
	{
		TiPullXmlElement* child = node->FirstChildElement( value );
		if ( child )
			return TiPullXmlHandle( child );
	}
	return TiPullXmlHandle( 0 );
}

TiPullXmlHandle TiPullXmlHandle::Child( int count ) const
{
	if ( node )
	{
		int i;
		TiPullXmlNode* child = node->FirstChild();
		for (	i=0;
				child && i<count;
				child = child->NextSibling(), ++i )
		{
			// nothing
		}
		if ( child )
			return TiPullXmlHandle( child );
	}
	return TiPullXmlHandle( 0 );
}

/*
TiPullXmlHandle TiPullXmlHandle::Child( const char* value, int count ) const
{
	if ( node )
	{
		int i;
		TiPullXmlNode* child = node->FirstChild( value );
		for (	i=0;
				child && i<count;
				child = child->NextSibling( value ), ++i )
		{
			// nothing
		}
		if ( child )
			return TiPullXmlHandle( child );
	}
	return TiPullXmlHandle( 0 );
}
*/

TiPullXmlHandle TiPullXmlHandle::ChildElement( int count ) const
{
	if ( node )
	{
		int i;
		TiPullXmlElement* child = node->FirstChildElement();
		for (	i=0;
				child && i<count;
				child = child->NextSiblingElement(), ++i )
		{
			// nothing
		}
		if ( child )
			return TiPullXmlHandle( child );
	}
	return TiPullXmlHandle( 0 );
}


TiPullXmlHandle TiPullXmlHandle::ChildElement( const char* value, int count ) const
{
	if ( node )
	{
		int i;
		TiPullXmlElement* child = node->FirstChildElement( value );
		for (	i=0;
				child && i<count;
				child = child->NextSiblingElement( value ), ++i )
		{
			// nothing
		}
		if ( child )
			return TiPullXmlHandle( child );
	}
	return TiPullXmlHandle( 0 );
}

int TiPullXmlDocument::FindLine(TiPullXmlCursor location) const
{
	int len = lineStarts.size();
	int low=0, mid, high=len-1;
	while (low <= high)
	{
		mid = (low + high) / 2;
		if (location.filepos >= lineStarts[mid])
		{
			if (mid+1 == len || (mid+1 < len && location.filepos < lineStarts[mid+1]))
			{
				return mid;
			}
			else
			{
				low = mid + 1;
			}
		}
		else
		{
			high = mid - 1;
		}
	}
	return -1;
}

int TiPullXmlDocument::ErrorRow() const
{
	return FindLine(errorLocation);
}

int TiPullXmlDocument::ErrorCol() const
{
	int k = FindLine(errorLocation);
	if (k >= 0 && k < lineStarts.size())
		return errorLocation.filepos - lineStarts[k];
	return -1;
}

int TiPullXmlNode::Row() const
{
	TiPullXmlDocument* doc = GetDocument();
	if (doc)
	{
		return doc->FindLine(startPos) + 1;
	}
	return -1;
}

int TiPullXmlNode::Column() const
{
	TiPullXmlDocument* doc = GetDocument();
	if (doc)
	{
		int k = doc->FindLine(startPos);
		if (k >= 0 && k < doc->lineStarts.size())
		{
			const char* fileBuffer = doc->getFileBuffer();
			int startOffset = doc->lineStarts[k];
			int retval = 0;
			int tabsize = doc->TabSize();
			for (k = startOffset; k < startPos.filepos; ++k)
			{
				if (fileBuffer[k] == '\t')
					retval += tabsize;
				else
					retval += 1;
			}
			return retval;
		}
	}
	return -1;
}

